/*
 * Author: Hiroyuki Chishiro
 * License: 2-Clause BSD
 */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#define WR_VALUE _IOW('a', 'a', int32_t *)
#define RD_VALUE _IOR('a', 'b', int32_t *)

#define MY_DEVICE_NAME "/dev/my_device"

int main(void)
{
  int fd;
  int32_t val, val2;

  if ((fd = open(MY_DEVICE_NAME, O_RDWR)) < 0) {
    perror("open");
    exit(1);
  }

  printf("Please input an integer: ");
  scanf("%d", &val);
  printf("write value = %d\n", val);
  ioctl(fd, WR_VALUE, (int32_t *) &val);

  ioctl(fd, RD_VALUE, (int32_t *) &val2);
  printf("read value = %d\n", val2);


  printf("Please input an integer: ");
  scanf("%d", &val);
  printf("write value = %d\n", val);
  write(fd, (int32_t *) &val, sizeof(int32_t));

  read(fd, (int32_t *) &val2, sizeof(int32_t));
  printf("read value = %d\n", val2);


  if (close(fd) < 0) {
    perror("close");
    exit(2);
  }

  return 0;
}
